#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "test_verbkb4xi.py">
#<abstract4xi abstract = "tests verbkb4xi"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<contextualize4xi context = "skeleton_print4xi.py"/>
#<use4xi usage = "
#  before running check:
#  1) test_verbkb4xi.py SKIPPED - you may not run these
#  2) > call t test_verbkb4xi > ..\txt\test_verbkb4xi.txt
#  3) analyse verb4xi.py - see DirectionKB4Xi to selects directions you want!
#  - trace OF COLOR_TENSES4XI with macro in test_verbkb4xi.txt and check
#  4) SUCCEEDED TO CREATE PIPE AND QUEUE COMMUNICATION MECHANISMS FOR PROCESSES 
#  5) SUCCEEDED TO SETUP COMMAND AND CONTROL WITH QUEUS AND PIPES
#  6) DONE such as TRIALS TO START REQUIRED PROCESSES
#  7) DONE TRIALS TO RUN REQUIRED PROCESSES 
#  8) DONE TRIALS TO GET ANSWERS TO CONTROL MESSAGES FROM QUEUES OF REQUIRED PROCESS
#  9) roger messages such as <roger4xi>roger2eight</roger4xi>
# 10) ack messages such as <ack2put4xi>queue2eight</ack2put4xi>
# 11) DONE TRIALS TO RECEIVE INFO ABOUT SUCCESFULL DICTIONARY PUT VIA PIPES FROM REQUIRED PROCESS/DIRECTION
# 12) DONE TRIALS TO GET <-- queues
# 13) DONE TRIALS TO RECEIVE <-- pipes <-- <roger4xi>roger2eight</roger4xi> ... <ack2put4xi>queue2eight</ack2put4xi>
#     <ack2put4xi>queue2one8shot2one33004xi</ack2put4xi> ... <ack2put4xi>queue2eight8shot2eight33004xi</ack2put4xi>
# 14) by tracing just DONE you'll get idea what happenened! 
# 15) test_verbkb4xi.py uses target functions such as charge2eight4xi which acticates DummyProcess4Xi with target fire2eight4xi
#     - above allows test_verbkb4xi.py continue its processing while fire2eight4xi is simultaneously running as a thread
#     - otherwise test_verbkb4xi.py would have to wait for target function!
# 16) command & control messages are necessary to syncronize queue and pipe usage and to quarantee data is flowing and passed ok
#"
#/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'main',
            'print_trace4xi',
            'test_verbkb4xi',            
            'set_trace4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging  
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from pickle4xi import pickle4xi
from pickle2a4xi import Pickle2a4Xi
from pickle2b4xi import Pickle2b4Xi
from pickle2c4xi import Pickle2c4Xi
from pickle2d4xi import Pickle2d4Xi
from pickle2e4xi import Pickle2e4Xi
from pickle2f4xi import Pickle2f4Xi
from pickle2g4xi import Pickle2g4Xi
from pickle2h4xi import Pickle2h4Xi
from pickle2i4xi import Pickle2i4Xi
from pickle2j4xi import Pickle2j4Xi
from pickle2k4xi import Pickle2k4Xi
from pickle2l4xi import Pickle2l4Xi
from pickle2m4xi import Pickle2m4Xi
from pickle2n4xi import Pickle2n4Xi
from pickle2o4xi import Pickle2o4Xi
from pickle2p4xi import Pickle2p4Xi
from pickle2q4xi import Pickle2q4Xi
from pickle2r4xi import Pickle2r4Xi
from pickle2s4xi import Pickle2s4Xi
from pickle2t4xi import Pickle2t4Xi
from pickle2u4xi import Pickle2u4Xi
from pickle2v4xi import Pickle2v4Xi
from pickle2w4xi import Pickle2w4Xi
from pickle2x4xi import Pickle2x4Xi
from pickle2y4xi import Pickle2y4Xi
from pickle2z4xi import Pickle2z4Xi
from pickle2_4xi import Pickle2_4Xi      

from print4xi import Print4Xi
from print4xi import print4xi
from print4xi import set_print_permission4xi

from skeleton_print4xi import SkeletonPrint4Xi
from skeleton_print4xi import skeleton_print4xi
from skeleton_print4xi import sense_function4xi
from skeleton_print4xi import reason_function4xi
from skeleton_print4xi import ace_function4xi

from time4xi import time4xi

from verb4xi import Verb4Xi
from verb4xi import analyze_verb4xi
from verb4xi import wave_verb4xi
from verb4xi import color_tenses4xi 
from verb4xi import sense_verb4xi
from verb4xi import reason_verb4xi
from verb4xi import ace_verb4xi

from xml_trace_sense4xi import xml_trace_sense4xi
from xml_trace_reason4xi import xml_trace_reason4xi
from xml_trace_ace4xi import xml_trace_ace4xi 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global t2xi 
global trace_object_count
global PickleKB4Xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
PickleKB4Xi = {
       'a': Pickle2a4Xi,
       'b': Pickle2b4Xi,
       'c': Pickle2c4Xi,
       'd': Pickle2d4Xi,
       'e': Pickle2e4Xi,
       'f': Pickle2f4Xi,
       'g': Pickle2g4Xi,
       'h': Pickle2h4Xi,
       'i': Pickle2i4Xi,
       'j': Pickle2j4Xi,
       'k': Pickle2k4Xi,
       'l': Pickle2l4Xi,
       'm': Pickle2m4Xi,
       'n': Pickle2n4Xi,
       'o': Pickle2o4Xi,
       'p': Pickle2p4Xi,
       'q': Pickle2q4Xi,
       'r': Pickle2r4Xi,
       's': Pickle2s4Xi,
       't': Pickle2t4Xi,
       'u': Pickle2u4Xi,
       'v': Pickle2v4Xi,
       'w': Pickle2w4Xi,
       'x': Pickle2x4Xi,
       'y': Pickle2y4Xi,
       'z': Pickle2z4Xi,
       '_': Pickle2_4Xi}
       

#"
#"/>

# ----------------------------------------------------------------------------------------------------------
#<function4xi function = "set2trace4xi" usage = "setting trace using definitions in pickle4xi functions !
#">                      
# ----------------------------------------------------------------------------------------------------------    
def set2trace4xi():
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    # print("(Step 0A/33) OF SET2TRACE4XI - STARTING SETTING TRACE BASED ON TRACE SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    # print("(Step 0B/33) OF SET2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080>    
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('=' *33)
        # print("STARTING LETTER : ", key2pickledb)
        # print('=' *33)
   
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("STARTING DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
        # 
        keys2dictionary = sorted(dictionary2pickle.keys())
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
            # -------------------------------------------------------------------------------------     
            # print('~' *33)        
            object2pickle = key2dictionary        
            # print("STARTING OBJECT: ", object2pickle)
            # print('~' *33)         
            # pickle4xi(object2pickle)
            # print('~' *33)                  
            # print("PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            # ---------------------------------------------------------------------------------    
            # Mark those with NACK4XI to be traced !
            # ---------------------------------------------------------------------------------     
            if dictionary2pickle[key2dictionary] == 'NACK4XI':
                set_param2xi = True     
                key_param = object2pickle     
                t2xi.set_print_permission(key_param, set_param2xi)
                # print("(Step 2A/33) OF SET2TRACE4XI - MARKED TO BE TRACED OBJECT: ", object2pickle)                                
                # 
            else:
                pass  
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('~' *33)        
        # print("COMPLETED  DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print('=' *33)
    # print("COMPLETED LETTER : ", key2pickledb)
    # print('=' *33)
    # ---------------------------------------------------------------------------------------------
    # 
    # ---------------------------------------------------------------------------------------------
    print('=' *33)
    print("(Step 33/33) OF SET2TRACE4XI - COMPLETED SETTING TRACE BASED ON NACK4XI/ACK4XI SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    print('=' *33)
    # 04:16:31 01/24/13 Pacific Standard Time
#</function4xi> 

       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "deny2trace4xi" usage = "
#   deny trace using pickle4xi functions !
#">                      
# -------------------------------------------------------------------------------------------------    
def deny2trace4xi():
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    print("(Step 01A/33) of DENY2TRACE4XI: STARTING DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    print("(Step 01B/33) OF DENY2TRACE4XI - USING T2XI: ", t2xi)
    # 04:16:31 01/24/13 Pacific Standard Time
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02A/33) OF DENY2TRACE4XI - STARTING LETTER : ", key2pickledb)
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("(Step 02B/33) OF DENY2TRACE4XI - STARTING DICTIONARY: ", dictionary2pickle)
        keys2dictionary = sorted(dictionary2pickle.keys())
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
   
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
   
            object2pickle = key2dictionary        
            # print("(Step 02C/33) OF DENY2TRACE4XI - STARTING OBJECT: ", object2pickle)
            # pickle4xi(object2pickle)        
            # print("STEP: PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            
            # ---------------------------------------------------------------------------------    
            # ACK4XI = tested .i.e. NOT to be traced! 
            # ---------------------------------------------------------------------------------     
            set_param2xi = 'ACK4XI'     
            key_param = object2pickle     
            t2xi.set_print_permission(key_param, set_param2xi)
            # print("(Step 02D/33) OF DENY2TRACE4XI - MARKED TESTED AND NOT to be traced: ", object2pickle)
            
            dictionary2pickle[key2dictionary] = 'ACK4XI' 
                    
        
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
            # print('~' *33)              
            # print("(Step 02Z/33) OF DENY2TRACE4XI *** FAILED - ERROR IN PICKLING OBJECT - NOT TO BE TRACED: ", object2pickle)
            # print('~' *33) 
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02E/33) OF DENY2TRACE4XI - COMPLETED  DICTIONARY: ", dictionary2pickle)
        # 
        
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print("(Step 02F/33) OF DENY2TRACE4XI - COMPLETED LETTER : ", key2pickledb)
    # _, a ... z            
    print("(Step 033/33) OF SET2TRACE4XI - COMPLETED DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi())
    # 04:16:31 01/24/13 Pacific Standard Time 
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "tailor2trace4xi" usage = "
#   tailors trace 
#">                      
# -------------------------------------------------------------------------------------------------    
def tailor2trace4xi():
    global trace_object_count
    global PickleKB4Xi 
    global t2xi
 
    print("(Step 001A/33) OF TAILOR2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080> 
                         
    # ---------------------------------------------------------------------------------------------
    # SETTINGS TO TAILOR TRACE - BE CAREFUL NOT TO SELECT TOO MANY AT A TIME!
    # ---------------------------------------------------------------------------------------------
    #<set4xi setting = "

    KB4Tailoring = {
        'Pipe4Xi': 'NACK4TRACE', 
        # 'PipeConnection4Xi': 'NACK4TRACE',
        # 'Popen4Xi': 'NACK4TRACE',
        # 'Process4Xi': 'NACK4TRACE',
        'Queue4Xi': 'NACK4TRACE',
        # '_ConnectionBase4Xi': 'NACK4TRACE'    
        }                             
                
    default3trace = 'NACK4TRACE' # we do NOT want trace if object is not found! 
    #"/>
    
    # ---------------------------------------------------------------------------------------------
    # PROCESS KB4Tailoring
    # ---------------------------------------------------------------------------------------------
    keys2tailor = sorted(KB4Tailoring.keys())
    for key2tailor in keys2tailor:
        # ---------------------------------------------------------------------------------    
        # NACK4XI = NOT TESTED .I.E. TO BE TRACED! 
        # ---------------------------------------------------------------------------------     
        set_param2xi = 'NACK4XI'     
        key_param = key2tailor    
        t2xi.set_print_permission(key_param, set_param2xi)
        print("(Step 002A/33) OF TAILOR_TRACE4XI - MARKED TO BE TESTED: ", key2tailor)
        # Pipe4Xi
        # PipeConnection4Xi
        # Popen4Xi
        # Process4Xi
        # Queue4Xi
        # _ConnectionBase4Xi
        
    # -----------------------------------------------------------------------------------------    
    # EOF KEYS
    # -----------------------------------------------------------------------------------------     
    print("(Step 0033/33) OF TAILOR_TRACE4XI - COMPLETED  TAILORING: ", time4xi())
    # 04:16:31 01/24/13 Pacific Standard Time

    
#</function4xi>       

  
# -------------------------------------------------------------------------------------------------
#<function4xi function = "print_trace4xi" usage = "
#   creates XML files
#">                       
# -------------------------------------------------------------------------------------------------    
def print_trace4xi(p2xi):
  

    # -------------------------------------------------------------------------------------------------
    # SENSE                        
    # -------------------------------------------------------------------------------------------------  
   
    context2sense = {
     'file_path4xi': '..\\..\\xml\\sense-test-verbkb4xi.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi2.com/sense/sw4xi/python32/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.yourdragonxi.org/web/lib/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Sensing of Multiprocessing4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Classes, methods and messages with context.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="Dragon4Xi#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Sensing Verbkb4Xi in Multiprocessing.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="sensed#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">Classes, Methods and Messages for Verbkb4Xi.</rdfs:comment>\n'}
      
    xml_trace_sense4xi(p2xi, context2sense)

    # -------------------------------------------------------------------------------------------------
    # REASON                         
    # -------------------------------------------------------------------------------------------------  
        
    context2reason = {
     'file_path4xi': '..\\..\\xml\\reason-test-verbkb4xi.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi4.com/reason/sw4xi/python32/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.dragonxi4.com/reason/sw4xi/python32/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Reasoning of Multiprocessing4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Operations</rdfs:comment>\n',
     'operation_comment4xi': '      <rdfs:comment xml:lang="en">Operations for Verbkb4Xi in Multiprocessing.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="reasoned#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Operations Verbkb4Xi in Multiprocessing.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="reason#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">reason</rdfs:comment>\n'}
       
    xml_trace_reason4xi(p2xi, context2reason)

    # -------------------------------------------------------------------------------------------------
    # ACE                         
    # -------------------------------------------------------------------------------------------------  
       
    context2ace = {
     'file_path4xi': '..\\..\\xml\\ace-test-verbkb4xi.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi8.com/ace/sw4xi/python32/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.dragonxi8.com/ace/sw4xi/python32/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Acing of Multiprocessing4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values for Verbkb4Xi in Multiprocessing.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="ACE4Xi#0000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values for Verbkb4Xi in Multiprocessing.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="ace#0000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">000000</rdfs:comment>\n'}   
    
    xml_trace_ace4xi(p2xi, context2ace)


    # -------------------------------------------------------------------------------------------------
    # end of print_trace4xi                        
    # -------------------------------------------------------------------------------------------------  
#</function4xi>
      
       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "test-verbkb4xi" usage = "
# tests verbkb4xi
#"> 
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def test_verbkb4xi():
    global t2xi
    global trace_object_count    
    from verb4xi import DirectionKB4Xi
     
    print("(Step 0/33) OF TEST_VERBKB4XI - DIRECTIONS TO BE TESTED ", time4xi())
    keys2direction = DirectionKB4Xi.keys()
    for key2direction in keys2direction:
        print(key2direction, ': ',DirectionKB4Xi[key2direction])
             
    # --------------------------------------------------------------------------------------------- 
    # INITIALIZE TRACE
    # ---------------------------------------------------------------------------------------------        
    t2xi = Print4Xi()
    print("(Step 1/33) OF TEST_VERBKB4XI - SET T2XI TO: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000005251EB8> 
    set2trace4xi()                                                                                               # trace all classes and functions in the system
    deny2trace4xi()                                                                                              # deny trace for all classes and functions in the system
    tailor2trace4xi()                                                                                            # tailor trace for this test   
    
    try:

        # ---------------------------------------------------------------------------------------------
        # START                          
        # ---------------------------------------------------------------------------------------------    
        print('=' *33)          
        print('TEST_VERBKB4XI: STARTING ', time4xi()) 
        print('=' *33)   
        # 
        
        debug2analyze = False
        
        if debug2analyze is True:
            # ---------------------------------------------------------------------------------------------
            # ANALYZE FUNCTION USAGE - OK                         
            # ---------------------------------------------------------------------------------------------    
            print('=' *33)          
            print('TEST_VERBKB4XI: ANALYZE VERBS BY FUNCTION', time4xi())
            # 02:21:42 01/24/13 Pacific Standard Time
            print('=' *33)      
            
            kb2xi = analyze_verb4xi()
            keys2kb = kb2xi.keys() 
    
            print('=' *70) 
            print("TEST_VERBKB4XI: ANALYZED VERBS BY FUNCTION KNOWLEDGE: ", time4xi())
            # 02:21:43 01/24/13 Pacific Standard Time
            
            for key2kb in sorted(keys2kb):
                print('\n', key2kb, ' : ', kb2xi[key2kb])
                # ...
                # =================================
                # VERB:  zero
                # DEFINITION OF  zero -VERB:  to amount to zero.
                # REFERENCE OF  zero -VERB:  2209
                # SYMBOL OF  zero -VERB:  2209
                # CLUSTER OF  zero -VERB:  4
                # COLOR OF  zero -VERB:  #088A85
                # ======================================================================
                # ANALYZED BY FUNCTION KNOWLEDGE:
                # CHECK-SUM-KEYS  :  1397
                # CHECK-SUM-TENSE  :  519
                # ESTIMATED-COUNT-TENSE  :  173
                # TOTAL-COUNT-ALPHA  :  27
                # TOTAL-COUNT-GRAPH  :  878
                # TOTAL-COUNT-KEYS  :  1397
                # TOTAL-COUNT-TENSE  :  519
                # TOTAL-COUNT-TENSE1  :  172
                #  TOTAL-COUNT-TENSE2OR3  :  347
                #  TOTAL-WARNINGS  :  0 
                # =================================
                # ...
        else:
            print('~' *33)          
            print('TEST_VERBKB4XI: ** SKIPPED ANALYZE BY FUNCTION - DEBUG2ANALYZE SET TO FALSE - SET TO TRUE, IF YOU WANT IT **', time4xi())
            print('~' *33)              
              
        # ---------------------------------------------------------------------------------------------
        # WAVE USING FUNCTION - OK                          
        # ---------------------------------------------------------------------------------------------    
        debug2wave = False
        
        if debug2wave is True:        
            print('=' *33)          
            print('TEST_VERBKB4XI: WAVE VERBS BY FUNCTION ', time4xi())  
            # 09:39:11 01/24/13 Pacific Standard Time
            print('=' *33)      
            
            kb2xi = wave_verb4xi()
            keys2kb = kb2xi.keys() 
    
            print('=' *70) 
            print("TEST_VERBKB4XI: WAVED VERBS BY FUNCTION ", time4xi())
            # 08:09:45 01/24/13 Pacific Standard Time
            
            for key2kb in sorted(keys2kb):
                print('\n', key2kb, ' : ', kb2xi[key2kb])
                # 'show':      ('show', 'tense2-to-fill', 'tense3-to-fill', 'tense4-to-fill', 1, 'to cause to be seen; exhibit;display.', 2, 3, '#BFF9E7'), 
                # 'skip':      ('skip', 'tense2-to-fill', 'tense3-to-fill', 'tense4-to-fill', 1, 'to pass over without reading, acting, calculating etc.', 2, 3, '#F78181'), 
                # 'terminate': ('terminate', 'tense2-to-fill', 'tense3-to-fill', 'tense4-to-fill', 1, 'to end, conclude or cease.', 2, 3, '#FE2E2E'), 
                # 'yearn':     ('yearn', 'tense2-to-fill', 'tense3-to-fill', 'tense4-to-fill', 1, 'to have a strong desire.', 2, 3, '#8000FF'), 
                # 'kill':      ('kill', 'tense2-to-fill', 'tense3-to-fill', 'tense4-to-fill', 1, 'to stop the operation of (process, task, etc.).', 2, 3, '#E15252'), 
                # ...   
                # zip  :  ('zip', 'tense2-to-fill', 'tense3-to-fill', 'tense4-to-fill', 1, 'to act with energy.', 2, 3, '#0B0B3B')
                # ...
                # zone  :  ('zone', 'tense2-to-fill', 'tense3-to-fill', 'tense4-to-fill', 1, 'to devide into zones.', 2, 3, '#0B0B61')
        else:
            print('~' *33)          
            print('** SKIPPED WAVE BY FUNCTION - DEBUG2WAVE SET TO FALSE - SET TO TRUE, IF YOU WANT IT**', time4xi())
            print('~' *33)   
                                              
        # ---------------------------------------------------------------------------------------------
        # SENSE USING FUNCTION - SKIPPED                          
        # ---------------------------------------------------------------------------------------------    
        debug2sense = False
        
        if debug2sense is True:     
        
            print('=' *33)          
            print('TEST_VERBKB4XI: SENSE BY FUNCTION ', time4xi())
            print('=' *33)      
        
            kb2xi = sense_verb4xi()
        
            print("TEST_VERBKB4XI: SENSED BY FUNCTION KNOWLEDGE = ", kb2xi)
        else:
            print('~' *33)          
            print('TEST_VERBKB4XI: ** SKIPPED SENSE BY FUNCTION - DEBUG2SENSE SET TO FALSE - SET TO TRUE, IF YOU WANT IT **', time4xi())
            print('~' *33)
                       
        # ---------------------------------------------------------------------------------------------
        # REASON USING FUNCTION - SKIPPED                           
        # ---------------------------------------------------------------------------------------------    
        debug2reason = False
        
        if debug2reason is True:     
            print('=' *33)          
            print('TEST_VERBKB4XI: REASON BY FUNCTION', time4xi())
            print('=' *33)       
        
            kb4xi = reason_verb4xi()
            print("TEST_VERBKB4XI: REASONED BY FUNCTION KNOWLEDGE = ", kb4xi)
        else:
            print('~' *33)          
            print('TEST_VERBKB4XI: ** SKIPPED REASON BY FUNCTION - DEBUG2REASON SET TO FALSE - SET TO TRUE, IF YOU WANT IT **', time4xi())
            print('~' *33)
            
                    
        # ---------------------------------------------------------------------------------------------
        # ACE USING FUNCTION - SKIPPED                           
        # ---------------------------------------------------------------------------------------------    
        debug2ace = False
        if debug2ace is True:           
            print('=' *33)          
            print('TEST_VERBKB4XI: ACE BY FUNCTION', time4xi())
            print('=' *33)       
        
            kb8xi = ace_verb4xi()
            print("TEST_VERBKB4XI: ACED BY FUNCTION KNOWLEDGE = ", kb8xi)    
        else:
            print('~' *33)          
            print('TEST_VERBKB4XI: ** SKIPPED ACE BY FUNCTION - DEBUG2ACE SET TO FALSE - SET TO TRUE, IF YOU WANT IT **', time4xi())
            print('~' *33)
                   
        # ---------------------------------------------------------------------------------------------
        # CREATE CLASS OBJECT - MANDATORY - OK                          
        # ---------------------------------------------------------------------------------------------       
        v2xi = Verb4Xi()
        print("TEST_VERBKB4XI: CREATED Verb4Xi CLASS OBJECT V2XI ", v2xi)  
        # <verb4xi.Verb4Xi object at 0x00000000038A4CC0>
             
        # ---------------------------------------------------------------------------------------------
        # ANALYZE USING CLASS OBJECT - SKIPPED                           
        # ---------------------------------------------------------------------------------------------    
        debug2analyze = False        
        
        if debug2analyze is True:
            print('=' *33)          
            print('TEST_VERBKB4XI: ANALYZE BY CLASS ', time4xi())
            print('=' *33)      
        
            kb2xi = v2xi.analyze_verb()
            keys2kb = kb2xi.keys() 
        
            print("TEST_VERBKB4XI: ANALYZED BY CLASS OBJECT ", time4xi())
        
            for key2kb in sorted(keys2kb):
                print('\n', key2kb, ' : ', kb2xi[key2kb])
        else:
            print('~' *33)          
            print('TEST_VERBKB4XI: ** SKIPPED ANALYZE BY CLASS - DEBUG2ANALYZE SET TO FALSE - SET TO TRUE, IF YOU WANT IT ** ', time4xi())
            print('~' *33)        
              
        # ---------------------------------------------------------------------------------------------
        # COLOR USING CLASS OBJECT - SKIPPED                          
        # ---------------------------------------------------------------------------------------------    
        debug2color = True  
        
        if debug2color is True:
            print('=' *33)          
            print('TEST_VERBKB4XI: COLOR TENSES BY CLASS', time4xi())
            print('=' *33)      
        
            kb2xi = v2xi.color_tenses()
            keys2kb = kb2xi.keys() 
        
            print("TEST_VERBKB4XI: COLORED BY CLASS OBJECT", time4xi())
        
            for key2kb in sorted(keys2kb):
                print('\n', key2kb, ' : ', kb2xi[key2kb])            
        else:
            print('~' *33)          
            print('TEST_VERBKB4XI: ** SKIPPED COLOR TENSES BY CLASS - DEBUG2COLOR SET TO FALSE - SET TO TRUE, IF YOU WANT IT **', time4xi())
            print('~' *33)                    
              
        # ---------------------------------------------------------------------------------------------
        # [ACK] - COORDINATE VERBS USING CLASS OBJECT - JATKA                          
        # ---------------------------------------------------------------------------------------------    
        debug2coordinate = True 
        if debug2coordinate is True:
            print('=' *33)          
            print('TEST_VERBKB4XI: COORDINATING TENSES BY CLASS ', time4xi()) 
            # 22:02:40 04/25/13 Pacific Daylight Time
            print('=' *33)      
            
            v2xi.coordinate_tenses('..//..//xml//reason-test-skeleton-print4xi.xml')
            
            print("TEST_VERBKB4XI: COORDINATED TENSES BY CLASS OBJECT ", time4xi())
            # 22:02:57 04/25/13 Pacific Daylight Timeme
        else:
            print('~' *33)          
            print('TEST_VERBKB4XI: ** SKIPPED COORDINATING TENSES BY CLASS  - SET TO TRUE, IF YOU WANT IT **', time4xi())
            print('~' *33)               

        # ---------------------------------------------------------------------------------------------
        # SENSE USING CLASS OBJECT - SKIPPED                         
        # ---------------------------------------------------------------------------------------------    
        ack2sense = False
        if ack2sense is True:
            print('=' *33)          
            print('TEST_VERBKB4XI: SENSE BY CLASS ', time4xi())
            print('=' *33)      
            
            kb2xi = v2xi.sense_verb()
            print("TEST_VERBKB4XI: SENSED BY CLASS KNOWLEDGE = ", kb2xi)
            
        else:
            print('~' *33)          
            print('TEST_VERBKB4XI: ** SKIPPED SENSE BY CLASS - ACK2SENSE SET TO FALSE - SET TO TRUE, IF YOU WANT IT ** ', time4xi())
            print('~' *33)                 


        
        # ---------------------------------------------------------------------------------------------
        # REASON USING CLASS OBJECT - SKIPPED                    
        # ---------------------------------------------------------------------------------------------    
        ack2reason = False
                
        if ack2reason is True:
            print('=' *33)          
            print('TEST_VERBKB4XI: REASON BY CLASS ', time4xi())
            print('=' *33)       
            
            kb4xi = v2xi.reason_verb()
            print("TEST_VERBKB4XI: REASONED BY CLASS KNOWLEDGE = ", kb4xi)
        else:
            print('~' *33)          
            print('TEST_VERBKB4XI: ** SKIPPED REASON BY CLASS - ACK2REASON SET TO FALSE - SET TO TRUE, IF YOU WANT IT** ', time4xi())
            print('~' *33)
                         
        # ---------------------------------------------------------------------------------------------
        # ACE USING CLASS OBJECT - SKIPPED                        
        # ---------------------------------------------------------------------------------------------    
        ack2ace = False
        
        if ack2ace is True:
            print('=' *33)          
            print('TEST_VERBKB4XI: ACE BY CLASS ', time4xi())
            print('=' *33)       
            
            kb8xi = v2xi.ace_verb()
            print("TEST_VERBKB4XI: ACED BY CLASS KNOWLEDGE = ", kb8xi)
        else:
            print('~' *33)          
            print('TEST_VERBKB4XI: ** SKIPPED ACE BY CLASS - ACK2ACE SET TO FALSE - SET TO TRUE, IF YOU WANT IT **', time4xi())
            print('~' *33)
                    
        # ---------------------------------------------------------------------------------------------
        # XML USING CLASS OBJECT                    
        # ---------------------------------------------------------------------------------------------    
        print('=' *33)          
        print('TEST_VERBKB4XI: XML BY CLASS ', time4xi())
        # 22:02:57 04/25/13 Pacific Daylight Time
        print('=' *33)       
        
        v2xi.xml_verb()
        print("TEST_VERBKB4XI: XML BY CLASS CREATED XML FILE REASON-VERB4XI.XML ", time4xi())
                        
        # ---------------------------------------------------------------------------------------------
        # DONE                          
        # ---------------------------------------------------------------------------------------------    
        print('=' *33)          
        print('TEST_VERBKB4XI: DONE!', time4xi())
        # 22:02:57 04/25/13 Pacific Daylight Time
        print('=' *33)
        
    finally:        
            
        # ---------------------------------------------------------------------------------------------    
        # Print Trace
        # ---------------------------------------------------------------------------------------------     
        print_trace4xi(t2xi)        
         
       
#</function4xi>
     

                   
    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "main" usage = "
#   main function for test_verbkb4xi
#"> 
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def main():

    print('=' *33)
    print("SENSING VERBS WITH YOURDRAGONXI ", time4xi())  
    print('=' *33)
    # 22:02:26 04/25/13 Pacific Daylight Time
        
    test_verbkb4xi()    
    
    print('=' *33)
    print("SENSED VERBS WITH YOURDRAGONXI ", time4xi())    
    print('=' *33) 
    # 22:03:01 04/25/13 Pacific Daylight Time                          
#</function4xi>
     

# -------------------------------------------------------------------------------------------------
# __main__                              
# -------------------------------------------------------------------------------------------------
if __name__ == '__main__':
    main()
    
#</program4xi>
 

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verbkb4xi.txt
#   reason-test-verbkb4xi.xml
#
#   Note: sense and ace are not referred because only verbs are being tested and reason XMl created
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of test_verbkb4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
